<?php
namespace Inti\Gath\Api;

/**
 * Pruža konfiguraciju za API.
 *
 * @package Inti\Gath\Api
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 */
final class ConfigProvider
{
    /**
     * @return array
     */
    public function __invoke(): array
    {
        return [
            'dependencies' => $this->getDependencies(),
        ];
    }

    /**
     * @return array
     */
    public function getDependencies(): array
    {
        return [
            'factories' => [
                'gath.http_client' => Service\HttpClientFactory::class,
                ClientInterface::class => Service\ClientFactory::class,
                Endpoint\Service\EndpointManager::class => Endpoint\Service\EndpointManagerFactory::class,
            ],
        ];
    }
}
