<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetMotoModelsByBrandQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetMotoModelsResult;

/**
 * Class GetMotoModels
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetMotoModelsResult call(GetMotoModelsByBrandQuery $query)
 */
final class GetMotoModelsByBrand extends GetMotoModels
{
    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetMotoModelsByBrandQuery || !is_array($query->Brands) || !count($query->Brands)) {
            return [];
        }

        return [
            'Brands' => $query->Brands,
        ];
    }
}
