<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetMotoModelsByIdsQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetMotoModelsResult;

/**
 * Class GetMotoModelsByIds
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetMotoModelsResult call(GetMotoModelsByIdsQuery $query)
 */
final class GetMotoModelsByIds extends GetMotoModels
{
    /** @var string */
    protected $method = 'GET';

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetMotoModelsByIdsQuery || !is_array($query->Id) || !count($query->Id)) {
            return [];
        }

        return [
            'Id' => $query->Id,
        ];
    }
}
