<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetMotoMotorcyclesByModelQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetMotoMotorcyclesResult;

/**
 * Class GetMotoMotorcyclesByModel
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetMotoMotorcyclesResult call(GetMotoMotorcyclesByModel $query)
 */
final class GetMotoMotorcyclesByModel extends GetMotoMotorcycles
{
    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetMotoMotorcyclesByModelQuery || !is_array($query->Models) || !count($query->Models)) {
            return [];
        }

        return [
            'Models' => $query->Models,
        ];
    }
}
