<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetMotoProductsQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductsResult;

/**
 * Class GetMotoProducts
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductsResult call(GetMotoProductsQuery $query)
 */
final class GetMotoProducts extends GetProducts
{
    /** @var string */
    protected $path = 'moto/articles';

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetMotoProductsQuery || !$query->MotoId || !is_array($query->GenArtIds) || !count($query->GenArtIds)) {
            return [];
        }

        return array_merge(parent::extractParams($query), [
            'MotoId' => $query->MotoId,
            'GenArtIds' => $query->GenArtIds,
        ]);
    }
}
