<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetProductAttributesByCategoryQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductAttributesResult;

/**
 * Class GetProductAttributeIdsByCategory
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductAttributesResult call(GetProductAttributesByCategoryQuery $query)
 */
final class GetProductAttributesByCategory extends AbstractEndpoint
{
    /** @var string */
    protected $method = 'POST';
    /** @var string */
    protected $path = 'category/attributes';
    /** @var string  */
    protected $resultClass = GetProductAttributesResult::class;

    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetProductAttributesByCategoryQuery || !count($query->Categories)) {
            return [];
        }

        return [
            'Categories' => $query->Categories,
        ];
    }
}
