<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetProductBrandsByCategoryQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductBrandsResult;

/**
 * Class GetProductBrandsByCategory
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductBrandsResult call(GetProductBrandsByCategoryQuery $query)
 */
final class GetProductBrandsByCategory extends GetProductBrands
{
    /** @var string */
    protected $method = 'POST';

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (
            !$query instanceof GetProductBrandsByCategoryQuery
            || (!$query->CategoryId && !$query->CategoryDataLink && !$query->CategorySlug)
        ) {
            return [];
        }

        return [
            'CategoryId' => $query->CategoryId,
            'CategoryDataLink' => $query->CategoryDataLink,
            'CategorySlug' => $query->CategorySlug,
            'Language' => $query->Language,
        ];
    }
}
