<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetProductCategoriesQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductCategoriesResult;

/**
 * Class GetCategories
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductCategoriesResult call(GetProductCategoriesQuery $query = null)
 */
final class GetProductCategories extends AbstractEndpoint
{
    /** @var string */
    protected $method = 'POST';
    /** @var string */
    protected $path = 'category';
    /** @var string */
    protected $resultClass = GetProductCategoriesResult::class;

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetProductCategoriesQuery) {
            return [];
        }

        return parent::extractParams($query);
    }
}
