<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetProductCategoryBySlugQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductCategoryResult;

/**
 * Class GetProductCategoryBySlug
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductCategoryResult call(GetProductCategoryBySlugQuery $query)
 */
final class GetProductCategoryBySlug extends AbstractEndpoint
{
    /** @var string */
    protected $method = 'GET';
    /** @var string */
    protected $path = 'category';
    /** @var string */
    protected $resultClass = GetProductCategoryResult::class;

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetProductCategoryBySlugQuery || !$query->Slug) {
            return [];
        }

        return [
            'Slug' => $query->Slug,
        ];
    }
}
