<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetProductIdsByTecDocIdsQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductIdsResult;

/**
 * Class GetProductIdsByTecDocIds
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductIdsResult call(GetProductIdsByTecDocIdsQuery $query)
 */
final class GetProductIdsByTecDocIds extends AbstractEndpoint
{
    /** @var string */
    protected $method = 'POST';
    /** @var string */
    protected $path = 'product/idsbytecdoc';
    /** @var string */
    protected $resultClass = GetProductIdsResult::class;

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetProductIdsByTecDocIdsQuery || !is_array($query->TecDocKeys) || !count($query->TecDocKeys)) {
            return [];
        }

        return [
            'TecDocKeys' => $query->TecDocKeys,
        ];
    }
}
