<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetProductsQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductsResult;

/**
 * Class GetProducts
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductsResult call(GetProductsQuery $query)
 */
abstract class GetProducts extends AbstractEndpoint
{
    /** @var string */
    protected $method = 'POST';
    /** @var string */
    protected $resultClass = GetProductsResult::class;

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetProductsQuery) {
            return [];
        }

        return [
            'Limit' => $query->Limit ?? 25,
            'Offset' => $query->Offset ?? 0,
            'OrderBy' => $query->OrderBy ?? GetProductsQuery::SORT_NAME_ASC,
            'SortNoStockLast' => $query->SortNoStockLast ?? false,
        ];
    }
}
