<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetProductsByAttributesQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductsResult;

/**
 * Class GetProductsByAttributes
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductsResult call(GetProductsByAttributesQuery $query)
 */
final class GetProductsByAttributes extends GetProducts
{
    /** @var string */
    protected $path = 'product/byattributes';

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetProductsByAttributesQuery || !count($query->Attributes)) {
            return [];
        }

        return array_merge(parent::extractParams($query), [
            'Attributes' => $query->toArray()['Attributes'],
            'Categories' => $query->Categories,
        ]);
    }
}
