<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetProductsByCategoryQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductsResult;

/**
 * Vraća proizvode za datu kategoriju.
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductsResult call(GetProductsByCategoryQuery $query)
 */
final class GetProductsByCategory extends GetProducts
{
    /** @var string */
    protected $path = 'product/bycategory';

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (
            !$query instanceof GetProductsByCategoryQuery
            || (!$query->CategoryId && !$query->CategoryDataLink && !$query->CategorySlug)
        ) {
            return [];
        }

        return array_merge(parent::extractParams($query), [
            'CategoryId' => $query->CategoryId,
            'CategoryDataLink' => $query->CategoryDataLink,
            'CategorySlug' => $query->CategorySlug,
        ]);
    }
}
