<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetProductsByIdsQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductsResult;

/**
 * Class GetProductsByIds
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductsResult call(GetProductsByIdsQuery $query)
 */
final class GetProductsByIds extends GetProducts
{
    /** @var string */
    protected $path = 'product/byids';

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetProductsByIdsQuery || !is_array($query->Ids) || !count($query->Ids)) {
            return [];
        }

        return array_filter(array_merge(parent::extractParams($query), [
            'Ids' => array_map('intval', $query->Ids),
            'TireIds' => $query->TireIds,
        ]));
    }
}
