<?php
namespace Inti\Gath\Api\Endpoint;

use Inti\Gath\Api\Query\GetProductsByTecDocIdsQuery;
use Inti\Gath\Api\Query\QueryInterface;
use Inti\Gath\Api\Result\GetProductsResult;

/**
 * Class GetProductsByTecDocIds
 *
 * @package Inti\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @method GetProductsResult call(GetProductsByTecDocIdsQuery $query)
 */
final class GetProductsByTecDocIds extends GetProducts
{
    /** @var string */
    protected $path = 'product/bytecdocids';

    /**
     * @param QueryInterface $query
     * @return array
     */
    protected function extractParams(QueryInterface $query): array
    {
        if (!$query instanceof GetProductsByTecDocIdsQuery || !count($query->TecDocKeys ?? [])) {
            return [];
        }

        return array_merge(parent::extractParams($query), [
            'TecDocKeys' => $query->toArray()['TecDocKeys'],
        ]);
    }
}
