<?php
namespace Inti\Gath\Api\Endpoint\Service;

use Interop\Container\ContainerInterface;
use Inti\Gath\Api\Endpoint\EndpointInterface;
use Inti\Gath\Api\ClientInterface;

/**
 * Kreira novu instancu krajnje točke.
 *
 * @package Inti\Gath\Api\Endpoint\Service
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 */
final class EndpointFactory
{
    /**
     * Stvara novu instancu krajnje točke.
     *
     * @param ContainerInterface $container
     * @param string $endpoint
     *
     * @return EndpointInterface
     */
    public function __invoke(ContainerInterface $container, string $endpoint): EndpointInterface
    {
        /** @var ClientInterface $client */
        $client = $container->get(ClientInterface::class);

        return new $endpoint($client);
    }
}
