<?php
namespace Inti\Gath\Api\Endpoint\Service;

use Inti\Gath\Api\Endpoint;
use Laminas\ServiceManager\AbstractPluginManager;

/**
 * Upravlja instancama krajnjih točaka APIja.
 *
 * @package Inti\Gath\Api\Endpoint\Service
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 */
final class EndpointManager extends AbstractPluginManager
{
    /** @var string */
    protected $instanceOf = Endpoint\EndpointInterface::class;
    /** @var array */
    protected $factories = [
        Endpoint\GetFeaturedCategories::class => EndpointFactory::class,
        Endpoint\GetFeaturedProducts::class => EndpointFactory::class,
        Endpoint\GetMotoBrands::class => EndpointFactory::class,
        Endpoint\GetMotoModelsByBrand::class => EndpointFactory::class,
        Endpoint\GetMotoModelsByIds::class => EndpointFactory::class,
        Endpoint\GetMotoMotorcyclesByIds::class => EndpointFactory::class,
        Endpoint\GetMotoMotorcyclesByModel::class => EndpointFactory::class,
        Endpoint\GetMotoProducts::class => EndpointFactory::class,
        Endpoint\GetProductAttributesByCategory::class => EndpointFactory::class,
        Endpoint\GetProductAttributes::class => EndpointFactory::class,
        Endpoint\GetProductBrands::class => EndpointFactory::class,
        Endpoint\GetProductBrandsByCategory::class => EndpointFactory::class,
        Endpoint\GetProductCategories::class => EndpointFactory::class,
        Endpoint\GetProductCategoryBySlug::class => EndpointFactory::class,
        Endpoint\GetProductIdsByTecDocIds::class => EndpointFactory::class,
        Endpoint\GetProductStock::class => EndpointFactory::class,
        Endpoint\GetProductPrice::class => EndpointFactory::class,
        Endpoint\GetProductsByAttributes::class => EndpointFactory::class,
        Endpoint\GetProductsByCategory::class => EndpointFactory::class,
        Endpoint\GetProductsByIds::class => EndpointFactory::class,
        Endpoint\GetProductsByTecDocIds::class => EndpointFactory::class,
    ];
}
