<?php
namespace Inti\Gath\Api\Query;

/**
 * Class GetProductIdsByTecDocIdsQuery
 *
 * @package Inti\Gath\Api\Query
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @property TecDocPair[] $TecDocKeys
 */
final class GetProductIdsByTecDocIdsQuery extends AbstractQuery
{
    /**
     * @return array
     */
    public function toArray(): array
    {
        $query = parent::toArray();
        $query['TecDocKeys'] = array_map(function (TecDocPair $tecDocPair) {
            return (array) $tecDocPair;
        }, $query['TecDocKeys']);

        return $query;
    }
}
