<?php
namespace Inti\Gath\Api\Query;

/**
 * Class GetProductsByAttributesQuery
 *
 * @package Inti\Gath\Api\Query
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @property AttributeValue[]   $Attributes
 * @property int[]              $Categories
 */
final class GetProductsByAttributesQuery extends GetProductsQuery
{
    /**
     * @return array
     */
    public function toArray(): array
    {
        $query = parent::toArray();
        $query['Attributes'] = array_map(function (AttributeValue $attributeValue) {
            return (array) $attributeValue;
        }, $query['Attributes']);

        return $query;
    }
}
