<?php
namespace Inti\Gath\Api\Record;

use RuntimeException;

/**
 * Class AbstractRecord
 *
 * @package Inti\Gath\Api\Record
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 */
abstract class AbstractRecord implements RecordInterface
{
    /** @var array */
    private $record = [];

    /**
     * Konstruktor.
     *
     * @param array $record
     */
    public function __construct(array $record)
    {
        $this->record = $record;
    }

    /**
     * @param string $name
     * @return mixed|null
     */
    public function __get(string $name)
    {
        return $this->record[$name] ?? null;
    }

    /**
     * @param string $name
     * @param $value
     */
    public function __set(string $name, $value)
    {
        throw new RuntimeException('Read-only object.');
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return $this->record;
    }
}
