<?php
namespace Inti\Gath\Api\Record;

/**
 * Class CategoryRecord
 *
 * @package Inti\Gath\Api\Record
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath
 *
 * @property string                     $Code
 * @property string                     $Name
 * @property string                     $ParentCode
 * @property int                        $ParentDataLink
 * @property string                     $Description
 * @property int                        $Menu_order
 * @property string                     $Slug
 * @property int                        $DataLink
 * @property string                     $_sale_badge_text
 * @property string                     $_sale_badge_size
 * @property string                     $_upsale_tecdoc_artid
 * @property string                     $_upsale_artcodes
 * @property string                     $genericArticleIds
 * @property string                     $genericArticleMotoIds
 * @property string                     $image
 * @property ProductCategoryRecord[]    $Children
 */
final class ProductCategoryRecord extends AbstractRecord
{
    /**
     * Konstruktor.
     *
     * @param array $record
     */
    public function __construct(array $record)
    {
        foreach ($record['Children'] ?? [] as $childRecord) {
            $children[] = new static($childRecord);
        }

        $record['Children'] = $children ?? [];

        parent::__construct($record);
    }

    public function toArray(): array
    {
        $array = parent::toArray();

        foreach ($this->Children ?? [] as $child) {
            $children[] = $child->toArray();
        }

        $array['Children'] = $children ?? [];
        return $array;
    }
}
