<?php
namespace Inti\Gath\Api\Result;

use Inti\Gath\Api\Record\RecordInterface;
use RuntimeException;

/**
 * Class AbstractResult
 *
 * @package Inti\Gath\Api\Result
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 *
 * @property RecordInterface[] $Results
 */
abstract class AbstractResult implements ResultInterface
{
    /** @var array */
    private $data;
    /** @var string */
    protected $recordClass;

    /**
     * Konstruktor
     *
     * @param array $data
     */
    public function __construct(array $data)
    {
        $recordClass = $this->recordClass;

        foreach ($data['Results'] ?? [] as $recordData) {
            $results[] = is_array($recordData)
                ? new $recordClass($recordData)
                : $recordData;
        }

        $data['Results'] = $results ?? [];
        $this->data = $data;
    }

    /**
     * @param string $name
     * @return mixed|null
     */
    public function __get(string $name)
    {
        return $this->data[$name] ?? null;
    }

    /**
     * @param string $name
     * @param $value
     */
    public function __set(string $name, $value)
    {
        throw new RuntimeException('Read-only object.');
    }
}
