<?php
namespace Inti\Gath\Api\Service;

use Inti\Gath\Api\Client;
use Inti\Gath\Api\ClientInterface;
use Psr\Container\ContainerInterface;

/**
 * Stvara novu instancu klijenta za Gath.
 *
 * @package Inti\Gath\Api\Service
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 */
final class ClientFactory
{
    /**
     * @param ContainerInterface $container
     * @return ClientInterface
     */
    public function __invoke(ContainerInterface $container): ClientInterface
    {
        $httpClient = $container->get('gath.http_client');
        return new Client($httpClient);
    }
}
