<?php
namespace Inti\Gath\Api\Service;

use GuzzleHttp\Client as HttpClient;
use GuzzleHttp\ClientInterface as HttpClientInterface;
use Psr\Container\ContainerInterface;

/**
 * Stvara novu instancu HTTP klijenta.
 *
 * @package Inti\Gath\Api\Service
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 */
final class HttpClientFactory
{
    /**
     * @param ContainerInterface $container
     * @return HttpClientInterface
     */
    public function __invoke(ContainerInterface $container): HttpClientInterface
    {
        /** @var array $config */
        $config = $container->get('config')['gath'] ?? [];

        return new HttpClient([
            'base_uri' => $config['base_uri'] ?? null,
            'timeout' => 10,
        ]);
    }
}
