<?php
namespace IntiTest\Gath\Api\Endpoint;

use GuzzleHttp\Client as HttpClient;
use Inti\Gath\Api\Client;
use Inti\Gath\Api\Endpoint\GetProductAttributes;
use Inti\Gath\Api\Result\GetProductAttributesResult;
use PHPUnit\Framework\TestCase;

/**
 * Class GetProductAttributesTest
 *
 * @package IntiTest\Gath\Api\Endpoint
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-gath-api
 */
final class GetProductAttributesTest extends TestCase
{
    public function testCanGetProductAttributes()
    {
        $httpClient = new HttpClient([
            'base_uri' => 'http://172.30.60.120:30024/',
            'timeout' => 2,
        ]);

        $client = new Client($httpClient);
        $endpoint = new GetProductAttributes($client);

        $result = $endpoint->call();
        $this->assertInstanceOf(GetProductAttributesResult::class, $result);
    }
}
